/**
 * This servlet is a simpler version of (ASC)GatewayPortal.java, useful
 * for testing.
 */

package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.Collaborator.*;

import org.omg.CORBA.*;
import java.lang.reflect.*;
import java.util.*;
import java.net.*;

public class CollClientSession extends HttpServlet {
						       
    public BOA boa;
    private ORB orb;
    private org.omg.CORBA.Object m1,m2,m3,m4,m5,m6,m7,m8,m9;

    private WebFlowContext ws = null;
    Collaborator coll;
    //PrintWriter out;

    private String ior;
    private WebFlowContext masterServer, userContext;
    private boolean notReady, masterOn, userContextOn;
    private int icount;
    private String masterRef, masterID;
    private String userName;
    private String sessionType;
    private String controlType;
    private String urlName;
    private boolean checkflag;
    ServletOutputStream out;
    MultipartResponse multi;

    //The following should be in a properties file.

    private String masterIOR="/home/scri97/users/cyoun/birch/GATEWAY/apache1.3.12/WWW/GOW/IOR/master.txt";
  
    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	doPost(req, res);
    }
    
    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	
	System.out.println("start servlet");
	//out = res.getWriter();
	out = res.getOutputStream();
	//res.setContentType("text/html");

	for(Enumeration clientparam = req.getParameterNames();
	    clientparam.hasMoreElements();) {
	    String tmp = (String)clientparam.nextElement();
	    System.out.println("Parameter Name: "+tmp);
	    if(tmp.equals("sessiontype")) { 
		checkflag = true;
		break;
	    }
	    else checkflag = false;
	}

	if(checkflag) {

	    userName = req.getParameter("username");
	    sessionType = req.getParameter("sessiontype");	
	    controlType = req.getParameter("controltype");

	    //userName="gateway";

	    if(sessionType.equals("join")) {

		/* attach modules */
		//out.println("Join session"+"<br>");
		m1 = CollabManager.getCollabSession(userName);
		coll = CollaboratorHelper.narrow(m1);
		String result = coll.test();
		//out.println(result+"<br>");

		coll.setUserId(userName);
		if(controlType.equals("master")) coll.setIsMaster(true);
		else coll.setIsMaster(false);
	       
		int mode = 1;
		coll.setCollabMode(mode);

		/*
		m1 = CollabManager.getCollaborator(userName);
		coll = CollaboratorHelper.narrow(m1);
		String result1 = coll.test();
		out.println(result1);
		*/
	    }
	    
	    if(sessionType.equals("leave")) {
		//out.println("Leave Session"+"<br>");
		CollabManager.removeCollSession(userName);
	    }
	   	
	} else {

	    userName = req.getParameter("username");
	    urlName = req.getParameter("urlname");

	    m1 = CollabManager.getCollaborator(userName);
	    coll = CollaboratorHelper.narrow(m1);
	    String result1 = coll.test();
	    //out.println(result1+"<br>");
	    //out.println("UserName: "+coll.getUserId()+"<br>");
	    //out.println("Control Type: "+coll.getIsMaster()+"<br>");
	    //out.println("Collab Mode: "+coll.getCollabMode()+"<br>");

	    if(coll.getIsMaster()) {
		//out.println("write File...."+"<br>");
		res.setContentType("text/html");
		coll.writeFile(urlName);
		coll.readFile("tmp");

		/*
		Enumeration collabUsers = CollabManager.collaboratorRef.keys();
		while(collabUsers.hasMoreElements()) {
		    String eachuser = (String)collabUsers.nextElement();
		    CollabManager.master.attachPushEvent;
		}
		*/
		//out.println(coll.getEventFlag());

		CollabManager.eventListeners(userName, "sharingPages");
		coll.runfireEvent("sharingPages", "webpage");
		
		while(true) {
		    synchronized(out) {
		    
			if(coll.getEventFlag()) {
			    //out.println(coll.getEventFlag());
			    
			    byte[] buf = coll.getBinaryBlock();
			    while(buf.length>1) {
				out.write(buf,0,buf.length);
				out.flush();
				buf = coll.getBinaryBlock();
			    } 
			    coll.setEventFlag(false);
			    break;
			}
		    }
			//try { Thread.sleep(1000); } catch(InterruptedException e) {}
		}
		
	    }
	    else {
		//out.println("Listening ......"+"<br>");
		multi = new MultipartResponse(res);
		
		while(true) {

		    System.out.println("UserName: "+userName);
		    m1 = CollabManager.getCollaborator("ejyoun");
		    coll = CollaboratorHelper.narrow(m1);

		    System.out.println("Before if flag check: "+coll.getEventFlag());
		    if(coll.getEventFlag()) {
			System.out.println("After if flag check: "+coll.getEventFlag());
			synchronized (out) {
			    coll.readFile("tmp");
			    
			    multi.startResponse("text/html");
			    
			    byte[] buf = coll.getBinaryBlock();
			    while(buf.length>1) {
				out.write(buf,0,buf.length);
				out.flush();
				buf = coll.getBinaryBlock();
			    } 
			    coll.setEventFlag(false);
			    multi.endResponse();
			}
		    }

		    try { Thread.sleep(1000); } catch(InterruptedException e) {}
		}

	    }
	    

	}  

	//out.println("CollClientSession has executed");
    
	System.err.println("about to flush 111");
	System.out.println("about to flush 222");
	out.flush();
	out.close();
    }
    
    void error(String msg)
    {
	//out.println(msg);
    }
    
    void status(String msg)
    {
	//out.println(msg);
    }
    
    public String getServletInfo()
    {
	return "By T. Haupt";
    }
    
    public synchronized void waitFor(long howLong) {
	try {
	    wait(howLong);
	} 
	catch (Exception e) {System.err.println(e);}
    }
    
    public String ReadIORFromFile(String masterIOR)   {
	//open a file
	FileInputStream theFile;
	BufferedReader fileReader;
	String sObjRef;
	
    try {
	theFile=new FileInputStream(masterIOR);
	fileReader=new BufferedReader(new InputStreamReader(theFile));
    }
    catch(FileNotFoundException e){
	return "";
    }
    
    //read a reference string
    try {
	sObjRef=fileReader.readLine();
	System.err.println("Got the reference: "+sObjRef);
    }
    catch (IOException e) {
	return "";
    }
    
    try {
	theFile.close();
	fileReader.close();
    }
    catch (IOException e) {}
    
    //return the reference string
    return sObjRef;
}

public boolean getMaster(String MasterRef){
    org.omg.CORBA.Object ws = orb.string_to_object(MasterRef);
    if(ws==null) return false;
    masterServer = WebFlowContextHelper.narrow(ws);
    if(masterServer==null) return false;
    else return true;
}
    
public boolean pingServer(WebFlowContext ws) {
    boolean non_exist = true;
    try{
	non_exist = ws._non_existent();
    }
    catch(org.omg.CORBA.COMM_FAILURE ex){}
    catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
    
    return !non_exist;
}       

private String getNameFromCookie(HttpServletRequest req) {
    String name=null;
    String cookieName="kerID";
	Cookie cookies[]=req.getCookies();
	Cookie myCookie=null;
	if(cookies!=null) {
	    for(int i=0;i<cookies.length;++i){
		if(cookies[i].getName().equals(cookieName)){
		    myCookie=cookies[i];
		    break;
		}
	    }
	}
	
	try{
	    name= URLDecoder.decode(myCookie.getValue());
	}
	catch(Exception e) {
	    System.out.println("Cookie value not available");
	    e.printStackTrace();
	}
	return name;
    }

}

