import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
                   
/* 
 * To Do:  need to modify idl222 and the hard path for WEBFLOW_IDL so
 * that the UserName is used instead.
 */
            
public class ConfWriteServ extends HttpServlet
{
    PrintWriter out;
    
    protected void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
	doPost(req,res);
    }

    protected void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException 
    {

	System.out.println("ConfWriteServ excuting");  	

	String UserName=req.getParameter("UserName");
	String ConfFile=req.getParameter("ConfFile");
	String MasterServer=req.getParameter("master");
	String IorURL="http://dev-spt01.asc.hpc.mil:8080/SciPortal/IOR/master.txt";


        String idl222="/hafs4/"+UserName+"/BeanContext_2.2.3/";	
	System.out.println("new conf file: "+ConfFile); 
	try {
	    FileWriter fw = new FileWriter(ConfFile);
	    fw.write("ServerName="+UserName+".\n");
	    fw.write("File=none\n");
	    fw.write("URL="+IorURL+"\n");
	    fw.write("PARENT="+MasterServer+"\n");
	    fw.write("WEBFLOW_IDL=/hafs4/"+UserName+"/BeanContext_2.2.3\n");
	    fw.write("Modules:===================\n");
	    fw.write("Charon " +idl222+"Charon/Charon.idl WebFlow.Charon.CharonServerImp\n");
	    fw.write("CharonObserv "+idl222+"Charon/Charon.idl WebFlow.Charon.CharonObserverImp\n");
	    fw.write("XmlServer "+idl222+"xml/xml.idl WebFlow.xml.XmlServerImpl\n");
  	    fw.write("ContextData "+idl222+"hashtable/hash.idl WebFlow.hashtable.ContextDataImpl\n");
  	    fw.write("SaveContext "+idl222+"hashtable/hash.idl WebFlow.hashtable.SaveContextImpl\n");
	    fw.write("gScript "+idl222+"gscript/gscript.idl WebFlow.gscript.gScriptImpl\n");
	    fw.write("submitJob "+idl222+"submitJob/submitJob.idl WebFlow.submitJob.submitJobImpl\n");
	    fw.write("RemoteFile "+idl222+"remotefile/remotefile.idl WebFlow.RemoteFile.RemoteFileImp\n");
	    fw.write("FileBrowser "+idl222+"filebrowser/filebrowser.idl WebFlow.FileBrowser.FileBrowserImp\n");
	    fw.write("ccm "+idl222+"ccm/ccm.idl WebFlow.ccm.ccmImpl\n");
	    fw.flush();
	    fw.close();
	} 
	catch(IOException ioe) {
	    System.out.println(ioe);
	}
    }
    
}

