package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.Base64.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;
import java.net.*;

public class Logout extends HttpServlet{

	ServletOutputStream out;
	ContextManager cm;
	private String userName; 
	private String option;
	private String problemName;

	public void doGet(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {

//          String auth = req.getHeader("authorization");
//          StringTokenizer st = new StringTokenizer(auth);
//          String copa = st.nextToken();
//          copa = st.nextToken();
//          Base64Decoder decoder = new Base64Decoder(copa);
//          try {
//            String decoded = decoder.processString();
//            StringTokenizer st1 = new StringTokenizer(decoded,":");
//            userName = st1.nextToken();
//          } catch (Exception e) {
//            System.err.println("cannot decode "+copa);
//            System.err.println(e);
//          } 

	    userName=getNameFromCookie(req);

  cm = ServerServlet.getContextManager(userName);  

  try {
  cm.stopSession();
  } catch (Exception e) {;}

  out = res.getOutputStream();
  res.setContentType("text/html");

  printHead("Logout");
  prnt("<center>");
  prnt("<h1>Thank you for using Gateway</h1>");
  prnt("all your data have been stored");
  prnt("<p><hr><p>");
  prnt("<a href=/SciPortal/admin.html target=\"_top\"> Log back </a>"); 
  out.println("</BODY>");    
  out.println("</HTML>");

  out.flush();
  out.close();

  }

  public void printHead(String title) {
    prnt("<html>");
    prnt("<TITLE>");
    prnt(title);
    prnt("\t</TITLE>");
    prnt("</HEAD>");
    prnt("<BODY STYLE=\"color:black;\" BGCOLOR=\"#f2fae4\" BACKGROUND=\"/SciPortal/ccmImages/bg1x.jpg\">");
    prnt("<H1 ALIGN=\"center\">"+title+"</H1>");
  }

 
  public void prnt(String msg){
    try{
      out.println(msg);
    } catch (Exception e){System.out.println(e);}
  }

    public String formatDate(String d){
      Date dateD=null;
      long dateL;
      SimpleDateFormat formatter = new SimpleDateFormat("s",Locale.getDefault());
      try {
      dateL = (new Long(d)).longValue();
      dateD = new Date(dateL);
      formatter.applyPattern("yyyy-MMM-d HH:mm:ss");
      } catch (Exception e) {System.out.println(e);}
      String dateS = formatter.format(dateD);
      return dateS;  
    }

  public String getServletInfo(){
    return "By T. Haupt and K. Flurchick";
  }

    private String getNameFromCookie(HttpServletRequest req) {
	String name=null;
	String cookieName="kerID";
	Cookie cookies[]=req.getCookies();
	Cookie myCookie=null;
	if(cookies!=null) {
	    for(int i=0;i<cookies.length;++i){
		if(cookies[i].getName().equals(cookieName)){
		    myCookie=cookies[i];
		    break;
		}
	    }
	}
	
	try{
	    name= URLDecoder.decode(myCookie.getValue());
	}
	catch(Exception e) {
	    System.out.println("Cookie value not available");
	    e.printStackTrace();
	}
	return name;
    }

}



