package WebFlow.Servlets;

import java.awt.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

//import com.oreilly.servlet.MultipartResponse;
//import com.oreilly.servlet.ServletUtils;

public class ViewerStub extends HttpServlet { 

    static final String LAUNCH = "WEB-INF/src/Servlets/download.bin";
    MultipartResponse multi;  
    ServletOutputStream out;
    Thread execR;
    RecvChannel rc;

    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	out = res.getOutputStream();  // some binary output

	// Prepare a multipart response
	multi = new MultipartResponse(res);

	/*
	rc = new RecvChannel(req, multi, out,ViewerStub.this);
	execR = new Thread(rc);
	execR.start();
	*/

	while(true) {
	    if(ServletUtils.filecontrolflag)
		recvMessage(req,multi,out);

	    try { Thread.sleep(1000); } catch (InterruptedException e) { }
	}

	// Don't forget to end the multipart response
	//multi.finish();
    }

    public void recvMessage(HttpServletRequest req, MultipartResponse multi, ServletOutputStream out) 
	throws ServletException, IOException {

	multi.startResponse("text/html");
	try {
	    ServletUtils.returnFile(req.getRealPath(LAUNCH), out);
	}
	catch (FileNotFoundException e) {
	    throw new ServletException("Could not find file: " + e.getMessage()); }
	multi.endResponse();
	ServletUtils.filecontrolflag = false;

    }
}
