import java.io.*;
import java.net.*;

public class Client1 {
    public static void main(String[] args) {
	if(args.length!=1) {
	    System.out.println("Usage: java Client port");
	    System.exit(1);
	}
	try {
	    String remotehost="localhost"; //"pet03.asc.hpc.mil";
	    int port=8585;
	    int myport=Integer.parseInt(args[0]);
	    int timeout=100000;

	    ServerSocket server=new ServerSocket(myport);
	    System.out.println("Can now accept connections.");
	    //Socket acceptor=server.accept();

	    while(true) {
	    Socket sender=server.accept();
	    //Socket sender=new Socket(remotehost,port);
	    //Socket sender=SocketFactory.openSocket(remotehost,port,timeout);
	    if(sender==null) {
		System.out.println("Could not contact remote host");
		System.exit(1);
	    }
	    else {
		System.out.println("Remote host contacted");
	    }

	    BufferedReader in=
		new BufferedReader(new 		
		    InputStreamReader(sender.getInputStream()));
	    PrintWriter out=
		new PrintWriter(sender.getOutputStream(),true);
	    
	    BufferedReader stdin=
		new BufferedReader(new InputStreamReader(System.in));

	    boolean cont=true;
	    while(cont){
		//Get message from the xterm.
		//String message=stdin.readLine();

		//Send the message to the server.
		//out.println(message);
		//out.flush();		

		//Get back the response from the server.
		String line=in.readLine();
		if(line!=null) {
		    //System.out.println(line);
		}
		else {
		    cont=false;
		}		
	    }
	    } //while(true)
	}
	catch(Exception ex) {
	    ex.printStackTrace();
	}
	
    }
}
