package extensions.Java3D;
import org.escience.XSIL.*;
import java.util.*;

public class Java3D extends XSIL {
	public Vector geometries;

	public void construct(){
	//	System.out.println("Java3D here");
		geometries = new Vector();
		XSIL x;
		for(int i=0; i<getChildCount(); i++){
			x = getChild(i);
			if(x instanceof Java3DGeometry) 
                    geometries.addElement((Java3DGeometry)x);
		}
	}

      public Vector getGeometries() {
        return geometries;
      }

	public String toString() {
		String ret = super.toString();
		ret += " [" + geometries.size() + " geometries]";
		return ret;
	}

	public String toLongString(){
		String s = toString();
		return s + "\n";
	}
}
