package org.escience.XSIL;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;

public class Comment extends XSIL {
	String Text;

	public void constructor(Element e){
		Text = "";
		super.constructor(e);
        Node node = e.getFirstChild();
        while(node != null){
            if(node.getNodeType() == Node.TEXT_NODE)
                Text += node.getNodeValue();
            node = node.getNextSibling();
        }
	}

	public String toString(){
		return super.toString() + " [" + Text + "]";
	}

	public String toLongString(){
		return toString() + "\n";
	}

	public String getText() {
		return Text;
	}

	public void objectToXSILString(
		PrintStream out, Hashtable h, String indent) {

		out.println(indent +
			"<Comment" + makeNameTypeTags() + ">"
			+ Text +
			"</Comment>");
	}
}
