package org.escience.XSIL;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;

public class Param extends XSIL {
	String Text = "";

	public void constructor(Element e){
		super.constructor(e);
        Node node = e.getFirstChild();
        while(node != null){
            if(node.getNodeType() == Node.TEXT_NODE)
                Text += node.getNodeValue();
            node = node.getNextSibling();
        }
		if(Type == null || Type.length() == 0){
			Type = "String";
		}
	}

	public String toString(){
		return super.toString() + " [" + Text + "]";
	}

	public String toLongString(){
		return super.toString() + "\tValue: " + Text + "\n";
	}

	public String getText() {
		return Text;
	}

	public void objectToXSILString(
		PrintStream out, Hashtable h, String indent) {

		out.println(indent + 
			"<Param" + makeNameTypeTags() + ">"
			+ Text + 
			"</Param>");
	}
}
