package org.escience.XSIL;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;

public class Url extends XSIL {
	String Text = "";
	String URLText = null;

	public void constructor(Element e){
		super.constructor(e);
        Node node = e.getFirstChild();
        while(node != null){
            if(node.getNodeType() == Node.TEXT_NODE)
                Text += node.getNodeValue();
            node = node.getNextSibling();
        }

		URLText = e.getAttribute("href");
	}	

	public void browseIt() {
        String browser = System.getProperty("browser.path");
        if(browser == null){
            System.out.println(
            "No browser configured. See documetation to configure this program");
        } else {
            System.out.println("Browser is " + browser);

            String command = browser + " " + URLText;

            Process p;
            try {
                p = Runtime.getRuntime().exec(command);
            } catch (Exception e) {
                System.err.println("Cannot open browser, please check the location");
            }
        }
	}

	public String toString(){
		return super.toString() + " [" + Text + "]";
	}

	public String toLongString(){
		return super.toString() + "\tValue: " + Text + "URL: " + URLText + "\n";
	}

	public String getText() {
		return Text;
	}

    public void objectToXSILString(
        PrintStream out, Hashtable h, String indent) {

        out.println(indent +
            "<Url" + makeNameTypeTags() + ">"
            + Text +
            "</Url>");
    }
}
