/**
 *
 */
package WebFlow.Servlets;

import entry.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.Base64.*;
import WebFlow.Charon.*;
import org.omg.CORBA.*;
import WebFlow.xml.*;
import WebFlow.hashtable.*;
import WebFlow.FB.*;
import WebFlow.ContextManager.*;
import WebFlow.RemoteFile.*;
import WebFlow.submitJob.*;
import java.lang.reflect.*;
import java.util.*;
import java.net.*;

/////Added////////////////////
//import orbasec.corba.Opaque;
/////Added////////////////////

public class ASCGatewayPortal extends HttpServlet {
						       
    public BOA boa;
    private ORB orb;
    private org.omg.CORBA.Object m1,m2,m3,m4,m5,m6,m7,m8;
    ContextData cd;
    SaveContext sc;
    ContextManager cm;
    XmlServer aad;
    RemoteFile rf;
    submitJob sj;
    FBServer fb;
    CharonServer charon;
    private WebFlowContext ws = null;
    PrintWriter out;
    private String ior;
    private WebFlowContext masterServer, userContext, slaveServer;
    private boolean notReady, masterOn, userContextOn;
    private int icount;
    private String masterRef, masterID;
    private String userName;

    /////Added////////////////////
    //org.omg.SecurityLevel2.SecurityManager security_manager=null;
    /////Added////////////////////

    //The following should be in a properties file.

    private String masterIOR="/a/birch.csit.fsu.edu/shared/home/cyoun/GATEWAY/apache1.3.12/WWW/SciPortal/IOR/master.txt";
    private final String userDir="/a/birch.csit.fsu.edu/shared/home/cyoun/GATEWAY/apache1.3.12/WWW/SciPortal/WEB-INF/Descriptors/users";
    private final String entryDir="/a/birch.csit.fsu.edu/shared/home/cyoun/GATEWAY/apache1.3.12/WWW/SciPortal/Entry";
    
    protected void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	doPost(req, res);
    }
    
    protected void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	
	System.out.println("start servlet");
	out = res.getWriter();
	res.setContentType("text/html");
	
//  	String[] args = new String[1];
//    	args[0]=req.getParameter("UserName");
//    	userName=args[0];
	
	userName=getNameFromCookie(req);

	System.out.println("userName= "+userName);

        /* first check whether the master server is already running */
        masterOn=false;
        System.out.println("Getting the master ior");
        masterRef = ReadIORFromFile(masterIOR);
        System.out.println("Returning from readIORFromFile"+masterRef);
        if(masterRef.length()>10) {
                System.out.println("About to get the orb");
                orb = ServerServlet.orb;
                System.out.println("Got the orb");
       if(getMaster(masterRef)) {
                    if(pingServer(masterServer)) {
                        masterOn=true;
                        masterID = masterServer.getObjectID();  
                    }
                }

        }
	
	if(!masterOn) {
	    out.println("Sorry, the Gateway Server is down.");
	}
	
	else {
	    
	    //cyoun added
	    System.out.println("Master ID: "+masterID);
	    slaveServer = WebFlowContextHelper.narrow(masterServer.getContext(masterID+"/"+userName+"."));
	    System.out.println("Slave WebFlow Context: "+slaveServer);
						     
	    /* attach modules */
	    
	    //	    m1 = masterServer.addNewModule("ContextData");
	    m1 = slaveServer.addNewModule("ContextData");
	    cd  = ContextDataHelper.narrow(m1);
	    cd.test();
	    
	    System.out.println("attach SaveContext"); 
	    
	    //	    m2 = masterServer.addNewModule("SaveContext");
	    m2 = slaveServer.addNewModule("SaveContext");
	    sc  = SaveContextHelper.narrow(m2);
	    sc.test();
	    
	    System.out.println("attach ContextManager"); 
	    
	    //	    m3 = masterServer.addNewModule("ContextManager");
	    m3 = slaveServer.addNewModule("ContextManager");
	    cm  = ContextManagerHelper.narrow(m3);
	    cm.test();
	    
	    System.out.println("attach aad"); 
	    
	    /*
	      m4 = masterServer.addNewModule("aad");
	      aad  = XmlServerHelper.narrow(m4);
	      aad.test();
	    */
	    
	    System.out.println("attach RemoteFile"); 
	    
	    //	    m5 = masterServer.addNewModule("RemoteFile");
	    m5 = slaveServer.addNewModule("RemoteFile");
	    rf  = RemoteFileHelper.narrow(m5);
	    rf.test();
	    
	    System.out.println("attach submitJob"); 
	    
	    //	    m6 = masterServer.addNewModule("submit");
	    m6 = slaveServer.addNewModule("submitJob");
	    sj  = submitJobHelper.narrow(m6);
	    sj.test();
      
	    System.out.println("attach FileBrowser"); 
	    //	    m7 = masterServer.addNewModule("FileBrowser");
	    m7 = slaveServer.addNewModule("FileBrowser");
	    fb  = FBServerHelper.narrow(m7);
	    fb.test();
	    
//  	    System.out.println("attach CharonServer");
//  	    m8=masterServer.addNewModule("Charon");
//  	    charon=CharonServerHelper.narrow(m8);
//  	    charon.test();

	    System.out.println("initialize ContextManager");             
	    
	    //cm.init(masterServer,m2,m5);
	    cm.init(slaveServer,m2,m5);
	    
	    System.out.println("userName="+userName);
	    System.err.println(cm.getObjectID());
	    
	    // register modules and user context (for perfomance)
	    //	    ServerServlet.setUserContext(userName,masterServer);
	    ServerServlet.setUserContext(userName,slaveServer);
	    ServerServlet.setContextManager(userName,cm);                     
	    ServerServlet.setFileBrowser(userName,fb);
	    ServerServlet.setRemoteFile(userName,rf);
	    ServerServlet.setSubmitJob(userName,sj);
	    //ServerServlet.setAAD(userName,aad);
	
	
	    //	    if(!cm.setUserContextData(masterServer,userDir,userName)) {
	    if(!cm.setUserContextData(slaveServer,userDir,userName)) {
		//Restore ContextData
		//read contents of the masterServerData
	    
		String rootDir = userDir + "/" + userName;
		//		sc.readContextData(masterServer,rootDir);
		sc.readContextData(slaveServer,rootDir);
		
		System.out.println("now restore contexts");
		//		restoreChildren(masterServer);
		restoreChildren(slaveServer);
	    }
	    //	    CopyWebPage("Portal.html");    
	    //CopyWebPage("Portal.jsp");
	    javax.servlet.RequestDispatcher rd;
	    rd=getServletContext().getRequestDispatcher("/Entry/Portal.html");
	    rd.include(req,res);
	}  
	
	System.err.println("about to flush 111");
	System.out.println("about to flush 222");
	out.flush();
	out.close();
    }
    
    void error(String msg)
    {
	out.println(msg);
    }
    
    void status(String msg)
    {
	//out.println(msg);
    }
    
    public String getServletInfo()
    {
	return "By T. Haupt";
    }
    
    public synchronized void waitFor(long howLong) {
	try {
	    wait(howLong);
	} 
	catch (Exception e) {System.err.println(e);}
    }
    
    public String ReadIORFromFile(String masterIOR)   {
	//open a file
	FileInputStream theFile;
	BufferedReader fileReader;
	String sObjRef;
	
	try {
	    theFile=new FileInputStream(masterIOR);
	    fileReader=new BufferedReader(new InputStreamReader(theFile));
	}
	catch(FileNotFoundException e){
	    return "";
	}
	
	//read a reference string
	try {
	    sObjRef=fileReader.readLine();
	    System.err.println("Got the reference: "+sObjRef);
	}
	catch (IOException e) {
	    return "";
	}
	
	try {
	    theFile.close();
	    fileReader.close();
	}
	catch (IOException e) {}
	
	//return the reference string
	return sObjRef;
    }
    
    public boolean getMaster(String MasterRef){
	org.omg.CORBA.Object ws = orb.string_to_object(MasterRef);
	if(ws==null) return false;
	masterServer = WebFlowContextHelper.narrow(ws);
	if(masterServer==null) return false;
	else return true;
    }
    
    public boolean pingServer(WebFlowContext ws) {
	boolean non_exist = true;
	try{
	    non_exist = ws._non_existent();
	}
        catch(org.omg.CORBA.COMM_FAILURE ex){}
	catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

        return !non_exist;
    }       

    public void CopyWebPage(String fileName) {

       try {
         FileReader fr = new FileReader(entryDir+"/"+fileName);
         BufferedReader in = new BufferedReader(fr);
         while(true) {  
          String nextLine = in.readLine();
          if(nextLine == null) break;
          out.println(nextLine);
	 } 
         in.close();
       } catch (Exception e) { System.out.println(e);}         
    } 


    private String getNameFromCookie(HttpServletRequest req) {
	String name=null;
	String cookieName="kerID";
	Cookie cookies[]=req.getCookies();
	Cookie myCookie=null;
	if(cookies!=null) {
	    for(int i=0;i<cookies.length;++i){
		if(cookies[i].getName().equals(cookieName)){
		    myCookie=cookies[i];
		    break;
		}
	    }
	}
	
	try{
	    name= URLDecoder.decode(myCookie.getValue());
	}
	catch(Exception e) {
	    System.out.println("Cookie value not available");
	    e.printStackTrace();
	}
	return name;
    }

    public void restoreChildren(WebFlowContext context) {
	System.out.println("starting restoration ...");
        if(cm==null) System.out.println("cm is null"); 
        if(context==null) System.out.println("context is null"); 
     String children=cm.getContextData(context,"Children");
     System.err.println("children: "+children); 
     String pDir=cm.getContextData(context,"Directory");
     System.err.println("directory: "+pDir); 
     if(children.equals("null")) { 
         // no more children: job done
         System.out.println("no more children: job done");
         return;
     }
     else {
         //Children are in format:  name1+name2+name3
         StringTokenizer st = new StringTokenizer(children,"+");
         while(st.hasMoreTokens()) {
             System.out.println("has more tokens");
	     String Child = st.nextToken();
             System.err.println("restore context "+Child);
             // create an empty context and put ContextData module to it
             WebFlowContext cc = restoreContext(context,Child);
             // a context name may have a suffix: .PC, .SC, or .AC. strip it
             String cDir = Child;
             int idx = Child.lastIndexOf(".");
             if(idx>-1) {
		 cDir = Child.substring(0,idx); 
             }  
             cDir = pDir+File.separator + cDir;
             System.out.println("cDir="+cDir);  
             sc.readContextData(cc,cDir);
             restoreChildren(cc);
	 }
     }
    }
    
  public WebFlowContext restoreContext(WebFlowContext p, String name){
    try {
    WebFlowContext c = WebFlowContextHelper.narrow(p.addNewContext(name));
    if(c==null) System.out.println("c is null");
    ContextData cdm = ContextDataHelper.narrow(c.addNewModule("ContextData"));
    if(cdm==null) System.out.println("--->cd is null");
    return c;
    } catch (Exception e) {
       System.out.println(e +"while createGatewayContext");
       return null;
    }  
  }


}

