package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
                   
/* This servlet takes the argument CookieID=kerberosID+Date and uses it to
 * set the value of the cookie for the client.
 */
            
public class CharonStart extends HttpServlet
{
    PrintWriter out;
    
    protected void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
	doPost(req,res);
    }

    protected void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException 
    {
	System.out.println("Servlet excuting");  	

	//First, clean up old session cookies, if present.
	HttpSession session=req.getSession(true);

	Cookie[] cookies=req.getCookies();
	for(int i=0;i<cookies.length;i++) {
	    System.out.println(cookies[i].getName());
	    if(cookies[i].getName().equals("SessionID"))
		cookies[i].setMaxAge(0);
	}

	//Now, set the new session cookie.  The cookie will not 
	//expire.
	String CookieID=req.getParameter("CookieID");
	String kerberosID=req.getParameter("sessionID");
	String UserName=req.getParameter("UserName");
	String host=req.getParameter("host");
	String jhost=req.getParameter("master");
	String jport=req.getParameter("jport");
	String relMasterIor=req.getParameter("relMasterIOR");
	String Display=req.getParameter("DISPLAY");

	System.out.println("CookieID="+CookieID+" kerberosID="+kerberosID);
	String CharonStart="/app/gateway/apache/htdocs/SciPortal/CharonStart.jsp";

	//Do this part if the cookie has not been set.  Creates a temporary 
	//startup page.  Clicking the button calls this servlets again,
	//but with CookieID set to the kerberosID.

	PrintWriter out=new PrintWriter(new FileWriter(CharonStart));
	out.println("<jsp:useBean id=\"chstart\" scope=\"session\" class=\"entry.CharonStartBean\"/>");
	out.println("<jsp:setProperty name=\"chstart\" property=\"userName\" value="+"\""+UserName+"\"/>");
	out.println("<html>");
	out.println("<head>");
	out.println("<body>");
	out.println("<form action=\"http://birch.csit.fsu.edu/SciPortal/servlet/WebFlow.Servlets.ASCGatewayPortal\" method=post>");
	out.println("<h1>Welcome to the the Charon Start page</h1>");
	out.println("<h1>Press the button to start</h1>");
  	out.println("<input type=hidden name=UserName value="+UserName+">");
//  	out.println("<input type=hidden name=host value="+host+">");
//  	out.println("<input type=hidden name=master value="+jhost+">");
//  	out.println("<input type=hidden name=jport value="+jport+">");
//  	out.println("<input type=hidden name=relMasterIOR value="+relMasterIor+">");
//  	out.println("<input type=hidden name=DISPLAY value="+Display+">");
	out.println("<input type=submit>");
	out.println("</form>");
	out.println("</body>");
	out.println("</html>");
	out.close();
    }
}




