/**
 * This servlet is a simpler version of (ASC)GatewayPortal.java, useful
 * for testing.
 */

package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.Collaborator.*;

import org.omg.CORBA.*;
import java.lang.reflect.*;
import java.util.*;
import java.net.*;

public class CollControl extends HttpServlet {
						       
    private org.omg.CORBA.Object m1;
    Collaborator coll;
    //PrintWriter out;

    private String userName;
    private String urlName;
    ServletOutputStream out;
    String eachuser;

    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	doPost(req, res);
    }
    
    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	
	System.out.println("start servlet");
	//out = res.getWriter();
	out = res.getOutputStream();
	res.setContentType("text/html");

	userName = req.getParameter("username");
	urlName = req.getParameter("urlname");

	m1 = CollabManager.getCollaborator(userName);
	coll = CollaboratorHelper.narrow(m1);
	String result1 = coll.test();
	//out.println(result1+"<br>");
	//out.println("UserName: "+coll.getUserId()+"<br>");
	//out.println("Control Type: "+coll.getIsMaster()+"<br>");
	//out.println("Collab Mode: "+coll.getCollabMode()+"<br>");

	if(coll.getIsMaster()) {
	    //out.println("write File...."+"<br>");
	    res.setContentType("text/html");

	    Enumeration activeUsers = CollabManager.hashKeys();
	    while(activeUsers.hasMoreElements()) {
		eachuser = (String)activeUsers.nextElement();
		coll.writeFile(eachuser, urlName);
	    }

	    coll.readFile(userName);

	    CollabManager.eventListeners(userName, "sharingPages");
	    coll.runfireEvent("sharingPages", "webpage");
		
	    //while(true) {
	    //synchronized(out) {
		    
	    //if(coll.getEventFlag()) {
			    
	    byte[] buf = coll.getBinaryBlock();
	    while(buf.length>1) {
		out.write(buf,0,buf.length);
		out.flush();
		buf = coll.getBinaryBlock();
	    } 
	    coll.setEventFlag(false);
	    //break;
	    //}
	    //}
		//try { Thread.sleep(1000); } catch(InterruptedException e) {}
	    //}
		
	}
	else {
	    out.println("Listening ......"+"<br>");
	}  

	//out.println("CollClientSession has executed");
    
	System.err.println("about to flush 111");
	System.out.println("about to flush 222");
	out.flush();
	out.close();
    }
    
}

