/**
 * This servlet is a simpler version of (ASC)GatewayPortal.java, useful
 * for testing.
 */

package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.Collaborator.*;

import org.omg.CORBA.*;
import java.lang.reflect.*;
import java.util.*;
import java.net.*;

public class CollRegister extends HttpServlet {
						       
    private org.omg.CORBA.Object m1;
    Collaborator coll;

    private String userName;
    private String sessionType;
    private String controlType;
    ServletOutputStream out;

    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	doPost(req, res);
    }
    
    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	
	System.out.println("start servlet");
	//out = res.getWriter();
	out = res.getOutputStream();
	res.setContentType("text/html");

	userName = req.getParameter("username");
	sessionType = req.getParameter("sessiontype");	
	controlType = req.getParameter("controltype");

	//userName="gateway";

	if(sessionType.equals("join")) {

	    /* attach modules */
	    out.println("<b>Join session"+"<br></b>");
	    m1 = CollabManager.getCollabSession(userName);
	    coll = CollaboratorHelper.narrow(m1);
	    String result = coll.test();
	    out.println(result+"<br>");

	    coll.setUserId(userName);
	    if(controlType.equals("master")) {
		if(!CollabManager.getControlFlag()) {
		    CollabManager.setControlFlag(true);
		    CollabManager.setControlUser(userName);
		    coll.setIsMaster(true);
		}
		else { 
		    out.println("<b>Somebody has already been controlled.<BR> You can not make it......<BR> Please register as the viewing mode. <br></b>");
		    CollabManager.removeCollSession(userName);
		    return;
		}
	    }
	    else coll.setIsMaster(false);
	    
	    int mode = 1;
	    coll.setCollabMode(mode);
	    out.println("You are in the collaborative environment.<br>");
	    
	    /*
	      m1 = CollabManager.getCollaborator(userName);
	      coll = CollaboratorHelper.narrow(m1);
	      String result1 = coll.test();
		out.println(result1);

	    if(!coll.getIsMaster()) {
		coll.writeJSP(userName);
		coll.readFile(userName);

		byte[] buf = coll.getBinaryBlock();
		while(buf.length>1) {
		    out.write(buf,0,buf.length);
		    out.flush();
		    buf = coll.getBinaryBlock();
		} 

	    }
	    */

	}

	if(sessionType.equals("leave")) {
	    out.println("<b>Leave Session"+"<br></b>");
	    CollabManager.removeCollSession(userName);
	    CollabManager.setControlFlag(false);
	    out.println("<b>Bye Bye ....... Now</b><br>");
	}
	   		
	out.println("<b>CollClientSession has executed</b>");
    
	System.err.println("about to flush 111");
	System.out.println("about to flush 222");
	out.flush();
	out.close();
    }
    
}


