/**
 * This servlet is a simpler version of (ASC)GatewayPortal.java, useful
 * for testing.
 */

package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.Collaborator.*;

import org.omg.CORBA.*;
import java.lang.reflect.*;
import java.util.*;
import java.net.*;

public class CollViewerPull extends HttpServlet {
						       
    private org.omg.CORBA.Object m1;
    Collaborator coll;
    //PrintWriter out;

    private String userName;
    String propspath;
    ServletOutputStream out;

    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	doPost(req, res);
    }
    
    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	
	System.out.println("start servlet");
	//out = res.getWriter();
	out = res.getOutputStream();
	res.setContentType("text/html");

	userName = req.getParameter("username");
	propspath = req.getRealPath("/WEB-INF/");
	propspath += "../Properties/Collab.properties";

	System.out.println("CollViewerPull:UserName: "+userName);
	m1 = CollabManager.getCollaborator(userName);
	coll = CollaboratorHelper.narrow(m1);

	if(!coll.getIsMaster()) {

	    //CollabManager.setFileName(userName, userName+"NEXT");
	    //CollabManager.setEventName(userName, userName+"NEXT");

	    coll.setCollabProperties(propspath);
	    coll.writeJSPInitial(userName);
	    coll.writeJSP(userName);
	    coll.readFile(userName);

	    byte[] buf = coll.getBinaryBlock();
	    while(buf.length>1) {
		out.write(buf,0,buf.length);
		out.flush();
		buf = coll.getBinaryBlock();
	    } 

	}
	    
	System.err.println("about to flush 111");
	System.out.println("about to flush 222");
	out.close();
    }
    
}






