/**
 * Program Name: nameEncodeBean.java
 * Comments: Turns phrases into single words by replacing spaces with
 * underscores.  Useful for converting user-supplied problem names into 
 * directories names that Unix can understand.
 */

package extensions.generic;

public class nameEncodeBean {
    public nameEncodeBean() {
	//Empty constructor
    }

    //Replace spaces with underscores
    public String encode(String name) {
	StringBuffer buffer=new StringBuffer(name);
	for(int i=0;i<buffer.length();i++) {
	    if(buffer.substring(i,i+1).equals(" "))
		buffer.replace(i,i+1,"_");
	}
	System.out.println("Encoded: "+buffer.toString());
	return buffer.toString();
    }

    public String decode(String name) {
	StringBuffer buffer=new StringBuffer(name);
	for(int i=0;i<buffer.length();i++) {
	    if(buffer.substring(i,i+1).equals("_"))
		buffer.replace(i,i+1," ");
	}
	System.out.println("Decoded: "+buffer.toString());
	return buffer.toString();
    }
}

