package extensions.generic;
import org.escience.XSIL.*;
import java.util.*;

public class parseXMLDesc extends XSIL {

    public String NumOfInParamType;
    public String NumOfInFileType;
    public String NumOfOutFileType;
    public String NumOfOutParamType;
    public String IOStyleText;
    
    public Vector hostList,hostListNames;
    public Vector vizList,vizListNames;

    boolean instantiated = false;
    
    public void construct(){
	hostList=new Vector();
	hostListNames=new Vector();
	vizList=new Vector();
	vizListNames=new Vector();

	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
		Param p = (Param)x;
		if(p.getName().equals("NumberOfInParams"))
		    NumOfInParamType = p.getText();
		if(p.getName().equals("NumberOfOutFiles"))
		    NumOfOutFileType = p.getText();
		if(p.getName().equals("NumberOfInFiles"))
		    NumOfInFileType=p.getText();
		if(p.getName().equals("NumberOfOutParams"))
		    NumOfOutParamType=p.getText();
		if(p.getName().equals("IOStyle"))
		    IOStyleText = p.getText();
	    }
  	    else if(x instanceof parseXMLHost) {
  		hostList.addElement((parseXMLHost)x);
  		//hostListNames.addElement(x.getName());
		hostListNames.addElement(((parseXMLHost)x).getHost());
  	    }
	    else if(x instanceof parseXMLViz) {
  		vizList.addElement((parseXMLViz)x);
  		vizListNames.addElement(x.getName());
		//vizListNames.addElement(((parseXMLHost)x).getHost());
	    }		
	}
    }
    
// This function does the heavy lifting of reading arrays and so on
// It is separate from the construction because it is not called unless necessary.

    public void instantiate(){
	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
		Param p = (Param)x;
		if(p.getName().equals("NumberOfInParams"))
		    NumOfInParamType = p.getText();
		if(p.getName().equals("NumberOfOutFiles"))
		    NumOfOutFileType = p.getText();
		if(p.getName().equals("NumberOfInFiles"))
		    NumOfInFileType=p.getText();
		if(p.getName().equals("NumberOfOutParams"))
		    NumOfOutParamType=p.getText();
		if(p.getName().equals("IOStyle"))
		    IOStyleText = p.getText();
	    }
	    else if(x instanceof parseXMLHost) {
		hostList.addElement((parseXMLHost)x);
		hostListNames.addElement(x.getName());
	    }
	    else if(x instanceof parseXMLViz) {
  		vizList.addElement((parseXMLViz)x);
  		vizListNames.addElement(x.getName());
		//vizListNames.addElement(((parseXMLHost)x).getHost());
	    }		
	} //for outer loop
    }
    
    public String getNumberOfInParams() { return NumOfInParamType; }
    public String getNumberOfOutFiles() { return NumOfOutFileType; }
    public String getNumberOfInFiles() { return NumOfInFileType;} 
    public String getNumberOfOutParams() { return NumOfOutParamType; }
    public String getIOStyle() { return IOStyleText; }
    public Vector getHostList() { return hostList; }
    public Vector getHostListNames() { return hostListNames; }
    public Vector getVizList() { return vizList; }
    public Vector getVizListNames() { return vizListNames; }

}



