/**
 * Applet for displaying job tracking information.
 * All the real work is pushed of to TrackPanel.java.  Major features
 * are 
 *    + Calls a servlet (TrackServ.java)
 *      to read the user's jobHash file (in a serialized hashtable)
 *      and displays this.
 *    + User can select and delete a finished job from the hashtable.
 */

package WebFlow.ToolBar;

import java.awt.*;
import javax.swing.*;

public class TrackerApplet extends JApplet {
    
    TrackPanel basePanel;
    
    public void init() {
	basePanel=new TrackPanel(this);
	Container contentPane=getContentPane();
	contentPane.add(basePanel);

	
    }
}



