package extensions.MyImage;
import org.escience.XSIL.*;
import java.util.Vector;
import java.awt.*;
import java.io.*;

public class MyImage extends XSIL {
	public Image image;
	public String PixelMin = "unknown";
	public String PixelMax = "unknown";
	public String RegionWidth = "unknown";
	public String ImageWidth = "unknown";
	public String RightAscension = "unknown";
	public String Declination = "unknown";

	public void construct(){
		System.out.println("MyImage here");
		for(int ichild=0; ichild < getChildCount(); ichild++){
            	XSIL x = getChild(ichild);
           		if(x instanceof Param){
				String n = ((Param)x).getName();
				String v = ((Param)x).getText();
				if(n.equals("PixelMin"))       PixelMin = v; else
				if(n.equals("PixelMax"))       PixelMax = v; else
				if(n.equals("RegionWidth"))    RegionWidth = v; else
				if(n.equals("ImageWidth"))     ImageWidth = v; else				
				if(n.equals("RightAscension")) RightAscension = v; else				
				if(n.equals("Declination"))    Declination = v; 
			}
			if(x instanceof Stream){
				InputStream is = ((Stream)x).getInputStream();
				byte[] data = getBytes(is);
				System.out.println("Read " + data.length + " bytes");
				image = Toolkit.getDefaultToolkit().createImage(data);
				Toolkit.getDefaultToolkit().prepareImage(image, -1, -1, null);
			}
		}
	}

	public String toString() {
		return getName();
	}

// Extract everything from the InputStream and make it into a byte
// array of exactly the right length.
	byte[] getBytes(InputStream is) {
		int bufsiz = 50000;
		byte[] a = new byte[bufsiz];
		byte[] b = null;
		byte[] c = new byte[0];
		int n, q = 0, blocks = 0;
		try {
			while((n = is.read()) != -1){
				a[q++] = (byte)n;
				if(q >= bufsiz){
					b = new byte[c.length + bufsiz];
					System.arraycopy(c, 0, b, 0, c.length);
					System.arraycopy(a, 0, b, c.length, bufsiz);
					c = b;
					q = 0;
					blocks++;
				}
			}
			b = new byte[c.length + q];
			System.arraycopy(c, 0, b, 0, c.length);
			System.arraycopy(a, 0, b, c.length, q);
		} catch (IOException e) {}
		return b;
	}
}