package extensions.ReadXML;
import org.escience.XSIL.*;
import java.io.*;

public class listParam extends XSIL {
	public static void main(String args[]) throws IOException {
		if (args.length != 1) {
			System.err.print("Usage: java extensions.Transform.listParam file.xml\n");
			System.exit(1);
		}
		XSIL root = new XSIL(args[0]);
		recurse(root);
	}

	public static void recurse(XSIL x) {
		for(int ichild=0; ichild < x.getChildCount(); ichild++){
			XSIL child = x.getChild(ichild);
			if(child instanceof Param){
				String Name = ((Param)child).getName();
				String Text = ((Param)child).getText();
				System.out.println("Name: " + Name + ", Text: " + Text);
			}
			recurse(child);
		}
	}
}