package org.escience.XSIL;
import java.io.*;

public class StringInputStream extends InputStream {
	String data;
	int pos;
	int len;
	byte b[];

	public StringInputStream(String data) {
		this.data = data;
		pos = 0;
		b = data.getBytes();
		len = data.length();
	}

	public int read() {
		if(pos < 0 || pos >= len)
			return -1;
		int result = (int)(b[pos]);
		pos++;
		return result;
	}

	public int available() {
		return len - pos;
	}

	public void close() {}
}
